<?php
/*
Version 1.01
*/

define('ACCESS_DIR',"./access/");

// 最近のアクセスの表示ログ数
define('LASTVISIT',10);

// 棒グラフ用の画像
define('BAR_IMAGE',"image/access/bar5.png");

function plugin_accessview_convert(){
	$args = func_get_args();
	$ret = readlog_accessview($args[0]);
	$timestamp = $ret[0];
	$ip = $ret[1];
	$host = $ret[2];
	$user_agent = $ret[3];

	$buf = "";

	// 一日平均訪問者数表示
	$buf .= countperday($timestamp);

	// 時間別訪問者数表示
	$buf .= rateoftime($timestamp);

	// 最近のアクセス表示
	$buf .= lastvisit($timestamp,$ip,$host,$user_agent);
	
	return $buf;
}

function countperday($timestamp){
	$count = 0;
	$d_start_day = $timestamp[0] + (60 * 60 * 24);
	$start = getdate($d_start_day);
	$start_day = mktime(0,0,0,$start['mon'],$start['mday'],$start['year']);
	// $d_end_day = $timestamp[count($timestamp) - 1];
	$d_end_day = time();
	$end = getdate($d_end_day);
	$end_day = mktime(0,0,0,$end['mon'],$end['mday'],$end['year']);

	$buf = "<h4>訪問者数 / 日</h4>\n";

	if ($start_day + (60 * 60 * 24) > $end_day){
		return $buf."設置してから十分に時間がたっていません\n";
	}
	
	for ($i = 0;$i < count($timestamp);$i++){
		$date = getdate($timestamp[$i]);
		if ($start_day <= $timestamp[$i] && $timestamp[$i] <= $end_day){
			$count++;
		}
	}


	$day = floor(($end_day - $start_day)/(60 * 60 * 24));
	$average = $count / $day;
	$average = round($average * 100);
	$average = $average / 100;

	$date = getdate($end_day);

	$buf .= "<p>".$date['mon']."月".$date['mday']."日までの平均：$average 人 / 日</p>\n";

	return $buf;
}

function rateoftime($timestamp){
	// バーの最大の長さ(100%における)
	$max_height = 300;
	$shadow_width = 2;

	$buf = "";

	$buf = "<h4>時間別訪問者数</h4>\n";
	
	$count = null;
	for ($i = 0;$i < count($timestamp);$i++){
		$date = getdate($timestamp[$i]);
		$hour = $date['hours'];
		av_Debug("hour",$hour);
		$count[$hour]++;
	}

	$data = "<tr>\n<td>時間帯</td><td>訪問者数</td><td>割合(%)</td><td>グラフ</td>\n</tr>\n";

	$sizepercount = $max_height / max($count);

	for ($i = 0;$i < 24;$i++){
		if ($count[$i] == null)
			$count[$i] = 0;
		$data .= "<tr>\n<td>$i</td><td>$count[$i]</td><td>".round($count[$i]/count($timestamp)*100)."%</td><td align=\"left\"><img src=\"".BAR_IMAGE."\" height=\"10\" width=\"".round($count[$i]*$sizepercount)."\"></td>\n</tr>\n";
	}

	$buf .= "<table cellspacing=\"2\" border=\"0\">\n";
	$buf .= $data;
	$buf .= "</table>\n";

	return $buf;
}

function lastvisit($timestamp,$ip,$host,$user_agent){

	$buf = "";

	$buf .= "<h4>最近の".LASTVISIT."アクセス</h4>\n";
	$buf .= "<table class=\"style_table\" cellspacing=\"1\" border=\"0\">\n";
	$buf .= "<tr><td class=\"style_td\">日付</td><td class=\"style_td\">ホスト情報</td><td class=\"style_td\">ブラウザ情報</td></tr>\n";
	if (count($timestamp) < LASTVISIT){
		for ($i = 0;$i < count($timestamp);$i++){
			$datestring = date("Y/m/d H:i:s (D)", $timestamp[$i]);
			$buf .= "<tr><td class=\"style_td\">$datestring</td><td class=\"style_td\">$host[$i]</td><td class=\"style_td\">$user_agent[$i]</td></tr>\n";
		}
	}else{
		for ($i = count($timestamp) - LASTVISIT;$i < count($timestamp);$i++){
			$datestring = date("Y/m/d H:i:s (D)", $timestamp[$i]);
			$buf .= "<tr><td class=\"style_td\">$datestring</td><td class=\"style_td\">$host[$i]</td><td class=\"style_td\">$user_agent[$i]</td></tr>\n";
		}
	}
	$buf .= "</table>\n";

	return $buf;
}

function readlog_accessview($page){
	global $timestamp,$ip,$host,$user_agent;

	//ログファイル名は？
	$filename = ACCESS_DIR.encode($page).".acc";

	//ファイルがある？ない？なければ作る。
	if(!file_exists($filename))
	{
		$nf = fopen($file, "w");
		fputs($nf,"\n");
		fclose($nf);
	}
	
	$array = file($filename);

	for ($i=0;$i < count($array);$i++){
		if ($array[$i] == "")
			continue;
		list($timestamp[],$ip[],$host[],$user_agent[]) = explode('__||__',$array[$i]);
	}
	
	$ret = array($timestamp,$ip,$host,$user_agent);
	return $ret;
}

function av_Debug($key,$msg){
	//echo "$key : $msg<br>";
}

?>